// -*- Mode: Java; indent-tabs-mode: t; tab-width: 4 -*-
// ---------------------------------------------------------------------------
// Multi-Phasic Applications: SquirrelJME
//     Copyright (C) Stephanie Gawroriski <xer@multiphasicapps.net>
//     Copyright (C) Multi-Phasic Applications <multiphasicapps.net>
// ---------------------------------------------------------------------------
// SquirrelJME is under the GNU General Public License v3+, or later.
// See license.mkd for licensing and copyright information.
// ---------------------------------------------------------------------------

package cc.squirreljme.runtime.lcdui.common;

/**
 * Common widget colors.
 *
 * @since 2018/12/02
 */
public interface CommonColors
{
	/** Default text color. */
	public static final int DEFAULT_TEXT_COLOR =
		0xFF_000000;
	
	/** Default text background color. */
	public static final int DEFAULT_TEXT_BACKGROUND_COLOR =
		0x00_FFFFFF;
	
	/** Border color. */
	public static final int BORDER =
		0xFF_000000;
	
	/** Background color. */
	public static final int BACKGROUND =
		0xFF_FFFFFF;
	
	/** Foreground color. */
	public static final int FOREGROUND =
		0xFF_000000;
	
	/** Disabled background. */
	public static final int DISABLED_BACKGROUND =
		0xFF_FFFFFF;
	
	/** Disabled foreground. */
	public static final int DISABLED_FOREGROUND =
		0xFF_3C3C3C;
	
	/** Highlighted border. */
	public static final int HIGHLIGHTED_BORDER =
		0xFF_0000FF;
	
	/** Highlighted background. */
	public static final int HIGHLIGHTED_BACKGROUND =
		0xFF_000080;
	
	/** Highlighted foreground. */
	public static final int HIGHLIGHTED_FOREGROUND =
		0xFF_FFFFFF;
	
	/** Disabled Highlighted background. */
	public static final int DISABLED_HIGHLIGHTED_BORDER =
		0xFF_000000;
	
	/** Disabled Highlighted background. */
	public static final int DISABLED_HIGHLIGHTED_BACKGROUND =
		0xFF_3C3C3C;
	
	/** Disabled Highlighted foreground. */
	public static final int DISABLED_HIGHLIGHTED_FOREGROUND =
		0xFF_9C9C9C;
	
	/** Canvas background. */
	public static final int CANVAS_BACKGROUND =
		0xFF_FFFFFF;
	
	/** Command bar background. */
	public static final int COMMANDBAR_BACKGROUND =
		0xFF_000000;
	
	/** Command bar foreground. */
	public static final int COMMANDBAR_FOREGROUND =
		0xFF_FFFFFF;
	
	/** Focused item color. */
	public static final int FOCUSED_COLOR =
		0xFF_FFFF00;
	
	/** Secondary focused item color. */
	public static final int FOCUSED_COLOR_TWO =
		0xFF_FF00FF;
}

